
;##### Phillips HST Senderoutinen ######
HST_Wait:	push	TempU1
		ldi	TempU1,19	;n
HST_Wait_l0:	dec	TempU1
		nop
		nop
		brne	HST_Wait_l0
		pop	TempU1
		ret			;Tx=13+(n-1)*5=106


HST_Impuls_1:	;36kHz Impuls fr 458us senden

		ldi	TempU1,17	;Anzahl Perioden
HST_I1_l0:	sbi	PortA,IROut_Bit	;2
		nop			;
		rcall	HST_Wait	;3
		dec	TempU1		;1
		breq	HST_I1_e	;1
		cbi	PortA,IROut_Bit	;2
		rcall	HST_Wait	;3
		nop
		rjmp	HST_I1_l0	
HST_I1_e:	cbi	PortA,IROut_Bit	;2
		ret			;

HST_Impuls_2:	;36kHz Impuls fr 458us senden

		ldi	TempU1,17	;Anzahl Perioden
HST_I2_l0:	cbi	PortA,IROut_Bit	;2
		nop			;
		rcall	HST_Wait	;3
		dec	TempU1		;1
		breq	HST_I2_e	;1
		sbi	PortA,IROut_Bit	;2
		rcall	HST_Wait	;3
		nop
		rjmp	HST_I2_l0	
HST_I2_e:	cbi	PortA,IROut_Bit	;2
		ret			;

HST_Pause:	ldi	WorkU1,9	;1
		rjmp	Pause_n50us	;3

HST_S_1:	rcall	HST_Impuls_1
		rjmp	HST_Pause
HST_S_0:	rcall	HST_Pause
		rjmp	HST_Impuls_1


HST_S_togg:	com	HiFi_Togg
		brne	HST_S_togg_0
		rcall	HST_Pause
		rcall	HST_Pause
		rcall	HST_Impuls_1
		rjmp	HST_Impuls_1
HST_S_togg_0:	rcall	HST_Impuls_1
		rcall	HST_Impuls_1
		rcall	HST_Pause
		rjmp	HST_Pause

HST_Send_Code:	;Daten in X
		cli
		rcall	HST_Impuls_1
		rcall	HST_Impuls_2
		rcall	HST_Impuls_1
		rcall	HST_Impuls_2
		rcall	HST_Impuls_1
		rcall	HST_Impuls_2	;2.8ms StartImp.
		rcall	HST_Pause
		rcall	HST_Pause
		rcall	HST_Impuls_1
		rcall	HST_Pause
		rcall	HST_Pause
		rcall	HST_Impuls_1
		rcall	HST_Pause
		rcall	HST_Impuls_1
		rcall	HST_Pause
		rcall	HST_Impuls_1
		rcall	HST_S_togg
		ldi	TempU2,16	;16bit
HST_SC_l0:	sbrc	X_H,7		;Bit 0 ?
		rcall	HST_S_1
		sbrs	X_H,7		;Bit 1 ?
		rcall	HST_S_0
		lsl	X_L
		rol	X_H
		dec	TempU2
		brne	HST_SC_l0
		sei
		ret
		




Send_HiFi:	;Sequenzen prfen
		ldd	WorkU1,Z+Taste
		ldd	TempU1,Z+TasteL1
		ldd	TempU2,Z+TasteL2

	;##POWER DIREKT
	cpi	WorkU1,Taste_SAT
	brne	Send_HiFi_cs00
	sbic	PortA,HiFiNetz_Bit	;HiFi_Aus ??
	rjmp	Send_HiFi_cs00		;ist schon an
	sbi	PortA,HiFiNetz_Bit	;HiFi_EIN !!
	rcall	ShowGer
	ret	;nach einschalten nix weiter ...
	;##	##	##

Send_HiFi_cs00:
		cpi	WorkU1,Taste_SAT
		brne	Send_HiFi_do1
		cpi	TempU1,Taste_SAT
		brne	Send_HiFi_do1
	;2x SAT gedrckt
		ldiw	X,0x113f	;Gert <TV>
		push	HiFi_Togg
		rcall	HST_Send_Code
		ldi	WorkU1,5		;100ms
		rcall	Pause_n20ms
		pop	HiFi_Togg
		rjmp	HST_Send_Code
Send_HiFi_do1:	
		cpi	WorkU1,Taste_GO
		brne	Send_HiFi_cs10
	;GO gedrckt
;		cpi	TempU1,Taste_SAT
;		brne	Send_HiFi_cs01
;	;SAT-GO gedrckt # Spannung einschalten
;		sbic	PortA,HiFiNetz_Bit	;HiFi_Aus ??
;		rjmp	Send_HiFi_csE		;ist schon an
;		sbi	PortA,HiFiNetz_Bit	;HiFi_EIN !!
;		rcall	ShowGer
;		ret	;nach einschalten nix weiter ...
		
Send_HiFi_cs01:	cpi	TempU1,Taste_EXIT
		brne	Send_HiFi_cs10
	;EXIT-GO gedr.
		cpi	TempU2,Taste_SAT
		brne	Send_HiFi_csE
	;SAT-EXIT-GO gedckt # Spannung abschalten
		cbi	PortA,HiFiNetz_Bit	;HiFi -> AUS
;		rcall	ShowGer
;### TV auch AUS
	;TV-EXIT-GO gedckt # Spannung abschalten
		ldd	TempU1,Z+TVistan
		tst	TempU1
		breq	Send_HiFi_tv01
		ldi	TV_Send_Code,11
		rcall	Send_TV_Send
		ldi	WorkU1,50		;1 sec
		rcall	Pause_n20ms
Send_HiFi_tv01:	sbi	PortA,TVNetz_Bit	;TV -> AUS
		clt
		bld	TVProgMODE,7	;Anzeige AUS
		rcall	ShowGer
;###########################

		ret	;nix weiter
		
Send_HiFi_cs10:	cpi	WorkU1,Taste_EXIT
		brne	Send_HiFi_cs11
	;EXIT gedr.
		cpi	TempU1,Taste_SAT
		brne	Send_HiFi_cs11
	;SAT-EXIT gedrckt # Ankndigung anzeigen
		ldi	DispDat,134
		rcall	Disp_Send_Code
		Text	Ank_Netz_AUS_1
		ldi	DispDat,192
		rcall	Disp_Send_Code
		Text	Ank_Netz_AUS_2
		ret	;nix weiter tun

Send_HiFi_cs11:	cpi	TempU1,Taste_EXIT
		brne	Send_HiFi_csE
		cpi	TempU2,Taste_SAT
		brne	Send_HiFi_csE
	;VCR-EXIT-<egal>  # Ankndigung lschen
		rcall	ShowGer
Send_HiFi_csE:	
;######################


		ldd	TempL1,Z+Taste
		dec	TempL1
		add	TempL1,TempL1	;*2
		PushZ
		ldiw_m	Z,HST_Codes
		clr	TempL2
		add	Z_L,TempL1
		adc	Z_H,TempL2
		lpm
		mov	X_H,r0
		ld	TempL1,Z+	;*** Z=Z+1
		lpm
		mov	X_L,r0
		PopZ
		;Sendecode in X
		cpi	X_H,$ff
		breq	Send_HiFi_E	;Sendecode vorhanden

		push	HiFi_Togg
		rcall	HST_Send_Code
		ldi	WorkU1,5		;100ms
		rcall	Pause_n20ms
		pop	HiFi_Togg
		rjmp	HST_Send_Code
Send_HiFi_E:	ret



HST_Codes:	
		.db	4,0
		.db	4,1
		.db	4,2
		.db	4,3
		.db	4,4
		.db	4,5
		.db	4,6
		.db	4,7
		.db	4,8
		.db	4,9
		.db	4,88		;Oben
		.db	4,89		;Unten
		.db	4,199		;Standby
		.db	16,13		;MUTE
		.db	255,255		;List/Counter
		.db	255,255		;List/Reset
		.db	4,91		;Rechts
		.db	4,90		;Links
		.db	4,92		;GO
		.db	255,255		;Stop
		.db	255,255		;Record
		.db	255,255		;List/Return
		.db	16,16		;Vol +
		.db	16,17		;Vol -
		.db	16,82		;Menu
		.db	255,255		;List
		.db	255,255		;List/Turn
		.db	255,255		;Exit	
		.db	4,48		;Grn
		.db	4,44		;Gelb
		.db	4,32		;Blau
		.db	4,33		;Rot	
		.db	0,63		;G-TV
		.db	255,255		;G-VCR
		.db	255,255		;G-SAT
		.db	255,255		;G-Licht
		.db	16,81
		.db	21,63