Get_Taste:	;Tastennummer ermitteln
		PushZ
		ldsw	Y,KeyCode
		subi	Y_H,1
		brcs	Beo_Key_Error
		cpi	Y_H,7
		brcc	Beo_Key_Error
		mov	TempL2,Y_L
		add	Y_H,Y_H		;*2
		ldiw_m	Z,BeoKeyTab
		clr	TempL1
		add	Z_L,Y_H
		adc	Z_H,TempL1	;Add CY
		lpm
		ld	Y_L,Z+		;**** Z=Z+1 ****
		mov	Y_L,r0
		lpm
		mov	Y_H,r0		;Adresse der Keycode-Tabelle einlesen
		mov_w	Z,Y
		lsl	Z_L
		rol	Z_H		;Adresse *2 da im FLASH
Beo_KeyN_Loop:	lpm			;Lade Tastencode ...
		ld	WorkU,Z+	;**** Z=Z+1 ****
		cp	r0,TempL2
		lpm			;Lade Tastennummer
		ld	WorkU,Z+	;**** Z=Z+1 ****
		breq	Beo_Key_Found
		tst	r0		;Tastennummer == 0 ?
		brne	Beo_KeyN_Loop
Beo_Key_Error:	PopZ
		clr	r0
		std	Z+Taste,r0
		std	Z+TasteL1,r0
		std	Z+TasteL2,r0
		ret
Beo_Key_Found:	PopZ
		ldd	TempU1,Z+TasteL1
		std	Z+TasteL2,TempU1
		ldd	TempU1,Z+Taste
		std	Z+TasteL1,TempU1
		std	Z+Taste,r0
		ret

Get_Geraet:	;Gertenummer ermitteln
		ldsw	Y,DevCode	;Gertecode
		andi	Y_L,0xFE	;Bit 0 lschen
		cpi	Y_H,1
		brne	Beo_Dev_M1
		cpi	Y_L,$6c		;0x6c oder 0x6d TV ??
		breq	Beo_Dev_TV
		cpi	Y_L,$80		;0x81 oder 0x80 V-Tape
		breq	Beo_Dev_VCR
Beo_NoDefDev:	clr	TempL1		;kein gltiges Gert
		std	Z+Taste,TempL1	;Taste lschen
		std	Z+Geraet,TempL1	;Gert lschen
		rcall	ShowGer
		clt	;T=0 -> FEHLER	;kein Befehl
		ret
Beo_Dev_M1:	cpi	Y_H,2
		brne	Beo_NoDefDev	;kein gltiges Gert
		cpi	Y_L,$4c		;0x4d oder 0x4c Licht
		brne	Beo_NoDefDev	;kein gltiges Gert
Beo_Dev_Light:	ldi	TempU1,4	;GERT=LICHT
Beo_Dev_Ok:	ldd	TempL1,Z+Geraet	;Gert alt ..
		cp	TempU1,TempL1
		breq	Beo_SameDev
		std	Z+Geraet,TempU1	;Gert speichern
		rcall	ShowGer
		clr	TempL1
		std	Z+TasteL1,TempL1	;letzte taste lschen
		std	Z+TasteL2,TempL1	;letzte taste lschen
Beo_Dev_END:	
Beo_SameDev:	set	;T=1		;Befehl vorhanden
		ret

Beo_Dev_VCR:	ldd	TempU1,Z+Taste	;Taste
		cpi	TempU1,34	;Gertetaste V-tape ?
		brne	Beo_Dev_END
		ldi	TempU1,2	;GERT=VCR
		rjmp	Beo_Dev_Ok
Beo_Dev_TV:	ldd	TempU1,Z+Taste	;Taste
		cpi	TempU1,33
		brcs	Beo_Dev_END
		cpi	TempU1,37
		brcc	Beo_Dev_END
		subi	TempU1,32
		rjmp	Beo_Dev_Ok

BeoKeyTab:	.dw	BeoKeys1,BeoKeys2,BeoKeys3,BeoKeys4,BeoKeys5,BeoKeys6,BeoKeys7
BeoKeys1:	;0x01nn
		.db	0x6c,33	;TV
		.db	0x73,34	;VTape
		.db	0x80,35	;SAT
		.db	0xb7,36	;LICHT
		.db	0x7e,37	;TEXT
		.db	0xFF,0
BeoKeys2:	;0x02nn
		.db	0x5f,38	;AV
		.db	0xFF,0
BeoKeys3:	;0x03nn
		.db	0x8f,29	;GRN
		.db	0x8e,30	;GELB
		.db	0x9a,31	;BLAU
		.db	0x9b,32	;ROT
		.db	0xFF,0
BeoKeys4:	;0x04nn
		.db	0x45,1	;0
		.db	0x46,2	;1
		.db	0x47,3	;2
		.db	0x48,4	;3
		.db	0x4b,5	;4
		.db	0x4c,6	;5
		.db	0x4d,7	;6
		.db	0x4e,8	;7
		.db	0x57,9	;8
		.db	0x58,10	;9
		.db	0x95,11	;OBEN
		.db	0x96,12	;UNTEN
		.db	0x5d,13	;Standby
		.db	0x5e,14	;MUTE
		.db	0xe7,15	;List/Counter
		.db	0x5f,16	;List/Reset
		.db	0xFF,0
BeoKeys5:	;0x05nn
		.db	0x23,17	;RECHTS
		.db	0x1f,18	;LINKS
		.db	0x24,19	;GO
		.db	0x25,20	;STOP
		.db	0x26,21	;REC
		.db	0x20,22	;RET
		.db	0xFF,0
BeoKeys6:	;0x06nn
		.db	0xcd,23	;Vol+
		.db	0xd3,24	;Vol-
		.db	0x79,25	;MENU
		.db	0x73,26	;LIST
		.db	0x33,27	;List/TURN
		.db	0xFF,0
BeoKeys7:	;0x07nn
		.db	0x1e,28	;EXIT
		.db	0x0b,29	;GRN
		.db	0x0c,30	;GELB
		.db	0x15,31	;BLAU
		.db	0x16,32	;ROT
		.db	0x05,11	;OBEN
		.db	0x06,12	;UNTEN
		.db	0x04,17	;RECHTS
		.db	0x03,18	;LINKS
		.db	0xFF,0
		
.equ	Taste_TV	= 33
.equ	Taste_VCR	= 34
.equ	Taste_SAT	= 35
.equ	Taste_GO	= 19
.equ	Taste_EXIT	= 28
.equ	Taste_STB	= 13