;##### METZ TV Senderoutinen ######
TV_Send_Imp:	;32kHz Impuls fr 500us senden

		ldi	TempU1,16
TSI_Loop:	sbi	PortA,IROut_Bit	;2t
		push	TempU1		;2t
		ldi	TempU1,39	;1	Tx=9+(n-1)*3
TSI_LoopH:	dec	TempU1		;1
		brne	TSI_LoopH	;1/2	=123T
		pop	TempU1		;2t
		nop			;1t	=124T
		nop			;1t	=125T == 15,625s

		cbi	PortA,IROut_Bit	;2
		push	TempU1		;2
		ldi	TempU1,38	;1	Tx=3+9+(n-1)*3
TSI_LoopL:	dec	TempU1		;1
		brne	TSI_LoopL	;1/2
		pop	TempU1		;2
		nop			;1
		nop			;1	2 extra
		dec	TempU1		;1
		brne	TSI_Loop	;2	=125T == 16,625s
		ret			;fLoop=32,0kHz * 500s

TV_Do_Pause:	;Pause fr TempU1 * 560us
		;TempU1 = Zeit
TDP_loop:	push	TempU1		;2	+
		ldi	TempU1,177	;1	+
TDP_loop1:	push	TempU1		;2	*
		ldi	TempU1,6	;1	*
TDP_loop2:	dec	TempU1		;1	*
		brne	TDP_loop2	;1/2	*=5 + (n-1) * 3	== 20T
		pop	TempU1		;2	+
		dec	TempU1		;1	+
		brne	TDP_loop1	;1/2	+=27 + (n-1) * 25 == 4477T = 559,6us
		pop	TempU1		;2
		dec	TempU1		;1
		brne	TDP_loop	;1/2
		ret			;4

TV_Send_OUT:	;Ausgabe 1x  Code in <TV_Send_Code>
		ldd	X_H,Z+METZ_BCnt	;Bitcounter laden
		mov	X_L,TV_Send_Code
		
		rcall	TV_Send_Imp
		ldi	TempU1,1	;560s
		rcall	TV_Do_Pause
		rcall	TV_Send_Imp
		ldi	TempU1,2	;1120s
		rcall	TV_Do_Pause
		rcall	TV_Send_Imp
		ldi	TempU1,5	;2800s
		rcall	TV_Do_Pause
		ldi	WorkU1,10	;10 Bit
		rcall	TV_Send_Imp
TV_S_O_loop:	lsr	X_H		;Counter 1->0->CY
		rol	X_L		;Daten   CY<-7<- ... 0<-CY	
		brcs	TV_S_O_b1
TV_S_O_b0:	;0 Bit senden			
		ldi	TempU1,3	;1680s
		rcall	TV_Do_Pause
		rcall	TV_Send_Imp
		ldi	TempU1,4	;2240s
		rcall	TV_Do_Pause
		rjmp	TV_S_o_be
TV_S_O_b1:	;1 Bit senden
		ldi	TempU1,1	;560s
		rcall	TV_Do_Pause
		rcall	TV_Send_Imp
		ldi	TempU1,2	;1120s
		rcall	TV_Do_Pause
TV_S_o_be:	rcall	TV_Send_Imp
		dec	WorkU1
		brne	TV_S_O_loop
		ret


TV_PWR_ON:	clt
		sbis	PortA,TVNetz_Bit	;schon AN?
		ret
		cbi	PortA,TVNetz_Bit	;TV EIN
		rcall	ShowGer
		ldi	WorkU1,255		;Pause fr 5s
		rcall	Pause_n20ms		;Pause einlegen
		ldi	TempU1,1
		std	Z+TVistan,TempU1
		ldi	TV_Send_Code,1	;(Ziffer 1)
		rcall	Send_TV_Send
		set
		bld	TVProgMODE,7	;Anzeige EIN
		;T=1 keine weiteren Aktionen
		ret
	
;##############################################################################
		
Send_TV:	;Sequenzen prfen
		ldd	WorkU1,Z+Taste
		ldd	TempU1,Z+TasteL1
		ldd	TempU2,Z+TasteL2
	;## POWER DIREKT
	cpi	WorkU1,Taste_TV
	brne	Send_TV_cs00
	rcall	TV_PWR_ON
	brtc	Send_TV_cs00
		rjmp	Send_HiFi	;HiFi noch auf TV schalten
	;ret
	;##	##	##
Send_TV_cs00:
		cpi	WorkU1,Taste_GO
		brne	Send_TV_cs10
	;GO gedrckt
;		cpi	TempU1,Taste_TV		PD
;		brne	Send_TV_cs01		PD
;	;TV-GO gedrckt # Spannung einschalten
;		rcall	TV_PWR_ON		PD
;		brtc	Send_TV_csE		PD
;		ret				PD
		
Send_TV_cs01:	cpi	TempU1,Taste_EXIT
		brne	Send_TV_cs10
	;EXIT-GO gedr.
		cpi	TempU2,Taste_TV
		brne	Send_TV_csE
	;TV-EXIT-GO gedckt # Spannung abschalten
		ldd	TempU1,Z+TVistan
		tst	TempU1
		breq	Send_TV_cs02
		ldi	TV_Send_Code,11
		rcall	Send_TV_Send
		ldi	WorkU1,50		;1 sec
		rcall	Pause_n20ms
Send_TV_cs02:	sbi	PortA,TVNetz_Bit	;TV -> AUS
		clt
		bld	TVProgMODE,7	;Anzeige AUS
		rcall	ShowGer
		ret	;nix weiter tun
	
Send_TV_cs10:	cpi	WorkU1,Taste_EXIT
		brne	Send_TV_cs11
	;EXIT gedr.
		cpi	TempU1,Taste_TV
		brne	Send_TV_cs11
	;TV-EXIT gedrckt # Ankndigung anzeigen
		ldi	DispDat,134
		rcall	Disp_Send_Code
		Text	Ank_Netz_AUS_1
		ldi	DispDat,192
		rcall	Disp_Send_Code
		Text	Ank_Netz_AUS_2
		ret	;nix weiter tun

Send_TV_cs11:	cpi	TempU1,Taste_EXIT
		brne	Send_TV_csE
		cpi	TempU2,Taste_TV
		brne	Send_TV_csE
	;TV-EXIT-<egal>  # Ankndigung lschen
		rcall	ShowGer
				
Send_TV_csE:	ldd	TempL1,Z+Taste
		PushZ
		ldiw_m	Z,TV_Codes
		dec	TempL1
		add	Z_L,TempL1
		adc	Z_H,ISNULL
		lpm
		mov	TV_Send_Code,r0
		PopZ
		cpi	TV_Send_Code,0xFF
		breq	Send_TV_END
		sbrc	TV_Send_Code,7		;Bit 7 gesetzt -> an HiFi
		rjmp	Send_HiFi	

		rcall	TV_ProgAuto
		brts	Send_TV_END		;nichts senden
Send_TV_Send:	cli	;Keine INT's
		ldd	TempU1,Z+METZ_BCnt
		inc	TempU1
		andi	TempU1,3
		std	Z+METZ_BCnt,TempU1	;neuer Bitcounter
		rcall	TV_Send_OUT
		sei
		ldi	WorkU1,5		;100ms
		rcall	Pause_n20ms
		cli
		rcall	TV_Send_OUT
		sei	;Interrups ein
Send_TV_END:	rcall	ShowTVProg
		ret		


TV_ProgAuto:	;Automatische Programmwahl 1/2 - stellig
		;Code in "TV_Send_Code"
		clt	;senden EIN
		ldd	TempU1,Z+TVistan
		tst	TempU1
		brne	TV_PA_m02
	;TV ist aus
		cpi	TV_Send_Code,12		;Tasten 0-9,-/--,STB schalten ein
		brcc	TV_PA_end	;TV nicht ein
		ldi	TempU1,1
		std	Z+TVistan,TempU1
		rjmp	TV_PA_m00
TV_PA_m02:	cpi	TV_Send_Code,11		;STB wenn TV ein
		brne	TV_PA_m00
		std	Z+TVistan,ISNULL
		clt
		bld	TVProgMode,0		;TextMode aus
		rjmp	TV_PA_end
TV_PA_m00:	;TV ist schon an oder geht mit nchstem Code an
		cpi	TV_Send_Code,10		;Tasten 0-9 ??
		brcc	TV_PA_m01	;-> nein
		sbrc	TVProgMode,0
		rjmp	TV_PA_m01	;-> im Textmode ! keine Zahlentasten auswerten
		mov	TempU1,TVProg
		cpi	TempU1,0xFF	;kein Prog ??
		brne	TV_PA_p01
		mov	TempU1,TV_Send_Code
		swap	TempU1			;Taste als Zehner speichern
		ori	TempU1,0x0F		;Einer frei
		mov	TVProg,TempU1
		ldiw	X,Time2Prog
		rcall	STimer0_START		;Zeit luft
		rjmp	TV_PA_end
TV_PA_p01:	;2. Programmtaste innerhalb von 3 sec
		mov	TempU1,TVProg
		andi	TempU1,0xF0
		or	TempU1,TV_Send_Code	;Einer speichern
		mov	TVProg,TempU1
	cli
		mov	X_L,SEC_CtrL
		mov	X_H,SEC_CtrH		;Timer RestZeit
	sei
;RZ = Restzeit (X)
;VZ = Volle Zeit (Time2Prog)
;MZ = Mindestwartezeit
;NZ = neue Zeit = MZ-(VZ-RZ) = MZ+RZ-VZ
		ldiw	Y,307		;1.25sec Mindestzeit
		add	X_L,Y_L
		adc	X_H,Y_H
		ldiw	Y,Time2Prog
		sub	X_L,Y_L
		sbc	X_H,Y_H
		brcs	TV_PA_p09	;Zeit schon um
		rcall	STimer0_START		;Restzeit ablaufen lassen
		rjmp	TV_PA_p_e
TV_PA_p09:	rcall	STimer0_END
TV_PA_p_e:	set			;nach dieser Routine
		ret			;keine Taste senden
TV_PA_m01:	cpi	TV_Send_Code,12		;Taste TV/TEXT
		brne	TV_PA_m03
		;Taste TEXT/TV gedrckt
		ldi	TempU1,1
		eor	TVProgMode,TempU1	;Mode negieren
		clr	TVProg
		dec	TVProg			;Programm lschen
TV_PA_m03:	;jede andere Taste beendet 2-Prog mode
		clr	TVProg
		dec	TVProg			;Programm lschen
TV_PA_end:	ret		


TV_Codes:	
		.db	0,1	;0
		.db	2,3	;2
		.db	4,5	;4
		.db	6,7	;5
		.db	8,9	;7
		.db	15,16	;OBEN
		;.db	16	;UNTEN
		.db	11,128+14	;Standby
		;.db	128+14	;Mute	(Bit 7 plus Tastennummer)
		.db	255,255	;List/Counter
		;.db	255	;List/Reset
		.db	13,14	;Rechts
		;.db	14	;Links
		.db	32,28	;Go
		;.db	28	;Stop
		.db	255,255	;Record
		;.db	255	;List/Return
		.db	128+23,128+24	;Vol +	(Bit 7 plus Tastennummer)
		;.db	128+24	;Vol -	(Bit 7 plus Tastennummer)
		.db	31,255	;Menu
		;.db	255	;List
		.db	255,29	;List/Turn
		;.db	29	;Exit
		.db	35,25	;Grn
		;.db	25	;Gelb
		.db	27,36	;Blau
		;.db	36	;Rot
		.db	128+33,255	;G-TV
		;.db	255	;G-VCR
		.db	255,255	;G-SAT
		;.db	255	;G-Licht
		.db	12,25	;Text
		;.db	24	;AV