VCR_Send_H:	ldi	TempU1,20
VCR_Send_HLoop:	sbi	PortA,IROut_Bit	;2
		push	TempU1		;2
		ldi	TempU1,43	;1
VCR_Send_HPL0:	dec	TempU1		;1
		brne	VCR_Send_HPL0	;1/2	9+(n-1)*3
		pop	TempU1		;2	=17us High
		tst	TempU1		;1
		
		cbi	PortA,IROut_Bit	;2
		push	TempU1		;2
		ldi	TempU1,23	;1
VCR_Send_HPL1:	dec	TempU1		;1
		brne	VCR_Send_HPL1	;1/2	;12+(n-1)*3
		pop	TempU1		;2	10us Low
		nop
		nop
		dec	TempU1		;1
		brne	VCR_Send_HLoop	;2
		ret

VCR_Send_H8:	;Startimpuls fr 9ms
		ldiw	X,333
VCR_Send_H8Loop:sbi	PortA,IROut_Bit	;2
		push	TempU1		;2
		ldi	TempU1,43	;1
VCR_Send_H8PL0:	dec	TempU1		;1
		brne	VCR_Send_H8PL0	;1/2	9+(n-1)*3
		pop	TempU1		;2	=17us High
		tst	TempU1		;1
		
		cbi	PortA,IROut_Bit	;2
		push	TempU1		;2
		ldi	TempU1,22	;1
VCR_Send_H8PL1:	dec	TempU1		;1
		brne	VCR_Send_H8PL1	;1/2	;15+(n-1)*3
		pop	TempU1		;2	10us Low
		nop
		nop
		ld	TempL1,-X	;2 *** X=X-1
		mov	TempL1,X_H	;1
		or	TempL1,X_L	;1
		brne	VCR_Send_H8Loop	;2
		ret
		
VCR_Send_L:	;Pause fr 0,7 ms
		ldi	WorkU1,14
		rjmp	Pause_n50us
		
VCR_Send_W:	;Daten senden Wert in X 
		ldi	TempU2,16	;16 Bits
VCR_Send_WLoop:	rcall	VCR_Send_H
		sbrc	X_H,7
		rcall	VCR_Send_L
		sbrc	X_H,7
		rcall	VCR_Send_L
		rcall	VCR_Send_L
		lsl	X_L		;CY<-L(7) L(1)<-0
		rol	X_H		;CY<-H(7) H(1)<-L(7)
		dec	TempU2
		brne	VCR_Send_WLoop
		ret


;##############################################################################

Send_VCR:	;Sequenzen prfen
		ldd	WorkU1,Z+Taste
		ldd	TempU1,Z+TasteL1
		ldd	TempU2,Z+TasteL2
	;## POWER DIREKT
	cpi	WorkU1,Taste_VCR
	brne	Send_VCR_cs00
	sbis	PortA,VCRNetz_Bit	;VCR_Aus ??
	rjmp	Send_VCR_cs00		;ist schon an
	cbi	PortA,VCRNetz_Bit	;VCR_EIN !!
	rcall	ShowGer
	ret	;nach einschalten nix weiter ...
	;##	##	##	
		
		
Send_VCR_cs00:
		cpi	WorkU1,Taste_GO
		brne	Send_VCR_cs10
	;GO gedrckt
;		cpi	TempU1,Taste_VCR
;		brne	Send_VCR_cs01
	;VCR-GO gedrckt # Spannung einschalten
;		sbis	PortA,VCRNetz_Bit	;VCR_Aus ??
;		rjmp	Send_VCR_csE		;ist schon an
;		cbi	PortA,VCRNetz_Bit	;VCR_EIN !!
;		rcall	ShowGer
;		ret	;nach einschalten nix weiter ...
		
Send_VCR_cs01:	cpi	TempU1,Taste_EXIT
		brne	Send_VCR_cs10
	;EXIT-GO gedr.
		cpi	TempU2,Taste_VCR
		brne	Send_VCR_csE
	;VCR-EXIT-GO gedckt # Spannung abschalten
		sbi	PortA,VCRNetz_Bit	;VCR -> AUS
		rcall	ShowGer
		ret	;nix weiter
		
Send_VCR_cs10:	cpi	WorkU1,Taste_EXIT
		brne	Send_VCR_cs11
	;EXIT gedr.
		cpi	TempU1,Taste_VCR
		brne	Send_VCR_cs11
	;VCR-EXIT gedrckt # Ankndigung anzeigen
		ldi	DispDat,134
		rcall	Disp_Send_Code
		Text	Ank_Netz_AUS_1
		ldi	DispDat,192
		rcall	Disp_Send_Code
		Text	Ank_Netz_AUS_2
		ret	;nix weiter tun

Send_VCR_cs11:	cpi	TempU1,Taste_EXIT
		brne	Send_VCR_csE
		cpi	TempU2,Taste_VCR
		brne	Send_VCR_csE
	;VCR-EXIT-<egal>  # Ankndigung lschen
		rcall	ShowGer
Send_VCR_csE:	
		;TV noch einschalten ...
		ldd	TempU1,Z+Taste
		cpi	TempU1,25
		breq	Send_VCR_tps
		cpi	TempU1,37
		breq	Send_VCR_tps
		cpi	TempU1,30
		brne	Send_VCR_tpe
Send_VCR_tps:	rcall	TV_PWR_ON
Send_VCR_tpe:		
		ldd	TempL1,Z+Taste
		dec	TempL1
		add	TempL1,TempL1	;*2
		PushZ
		ldiw_m	Z,VCR_Codes
		clr	TempL2
		add	Z_L,TempL1
		adc	Z_H,TempL2
		lpm
		mov	X_L,r0
		ld	TempL1,Z+	;*** Z=Z+1
		lpm
		mov	X_H,r0
		PopZ
		;Sendecode in X
		cpi	X_H,$ff
		brne	Send_VCR_Ms	;Sendecode vorhanden
		tst	X_L
		breq	Send_VCR_END	;kein Sendecode
		rjmp	Send_HiFi
		
Send_VCR_Ms:	PushX
		rcall	VCR_Send_H8
		ldi	WorkU1,88	;4.4ms
		rcall	Pause_n50us
		ldiw	X,$7689
		rcall	VCR_Send_W
		PopX
		rcall	VCR_Send_W
		rcall	VCR_Send_H
Send_VCR_END:	ret
		
		
		
VCR_Codes:	
		.dw	0x20DF	;0
		.dw	0xA05F	;1
		.dw	0x609F	;2
		.dw	0xE01F	;3
		.dw	0x30CF	;4
		.dw	0xB04F	;5
		.dw	0x708F	;6
		.dw	0xF00F	;7
		.dw	0x38C7	;8
		.dw	0xB847	;9
		.dw	0x41BE	;Oben
		.dw	0x916E	;Unten
		.dw	0x28D7	;Standby
		.dw	0xFF00+14	;Mute
		.dw	0x12ED	;List/Counter
		.dw	0xF807	;List/Reset
		.dw	0x09F6	;Rechts
		.dw	0xC13E	;Links
		.dw	0x718E	;Go
		.dw	0x807F	;Stop
		.dw	0x906F	;Record
		.dw	0xFF00	;List/Return
		.dw	0xFF00+23	;Vol +
		.dw	0xFF00+24	;Vol -
		.dw	0x6897	;Menu
		.dw	0xFF00	;List
		.dw	0x00FF	;List/Turn
		.dw	0xA857	;Exit
		.dw	0xD02F	;Grn
		.dw	0x10EF	;Gelb
		.dw	0xC03F	;Blau
		.dw	0x40BF	;Rot
		.dw	0xFF00	;G-TV
		.dw	0xFF00	;G-VCR
		.dw	0xFF00	;G-SAT
		.dw	0xFF00	;G-Licht
		.dw	0xE21D	;Text
		.dw	0x6A95	;AV